<?

/* 

This is the global configuration file. These values are used in 
most parts of Pivot. Best not to tamper with them, unless you 
know what you're doing!

For now you will have to edit these by hand, but in the final 
release there will be much more straightforward preferences 
screens when you're logged in to Pivot as an Admin.. (if this 
file is not complete, your log will act iffy. Be careful!)

*/


$global_pref['debug']=FALSE;

$global_pref['local_path']='../';

$global_pref['index']='index.php';
$global_pref['file_format']='entry_%1.php';
$global_pref['archive_amount']=1;
$global_pref['archive_unit']="month";
$global_pref['archive_format']="archive_%1.html";
$global_pref['archive_order']="chronological";

$global_pref['backup_path']="backup/";

$global_pref['wysiwyg_editor']=TRUE;
$global_pref['allow_paragraphs']=FALSE;
$global_pref['ping_weblogs']=FALSE;
$global_pref['targetblank']=TRUE;
$global_pref['rss']="rss.xml";
$global_pref['rss_entry_length']=300;
$global_pref['emoticons']=TRUE;
$global_pref['encode_email_addresses']=FALSE;

$global_pref['log_access']= TRUE;
$global_pref['live_comments']= TRUE;

$global_pref['readmore'] = "(more)";

// some settings for the internal workings of pivot.
$global_pref['overview_entriesperpage']=20;
$global_pref['max_chars']=40;
$global_pref['sort_by']="date";
$global_pref['redirect']="relative";
$global_pref['entries_per_dir']=100;



// some settings for comments..
$global_pref['comment_sendmail']=0;
$global_pref['comment_emailto']="you@yourdomain.com";
$global_pref['texttolinks']='Y';
$global_pref['comment_wrap']='100';
$global_pref['comments'] = "No comments yet|Only %num% comment|%num% comments, already";
$global_pref['comments_numbers'] = "zero|one|two|three|four|five|six|seven|eight|nine|ten|eleven|twelve|thirteen|fourteen|fifteen|sixteen";


// if you have problems receiving mail from comments, setting this to TRUE might help.
$global_pref['comment_mail_before']=FALSE;


// some settings for time offset. Useful when the webserver is not in the
// same timezone as your projected audience..
// unit can be 'y', 'm', 'd', 'h', 'i', meaning respectively year, month, day, hour, minutes
$global_pref['timeoffset_unit']='h';
$global_pref['timeoffset']=0;


$global_pref['weekdays'] = explode(",", "Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday");
$global_pref['months'] = explode(",", "January,February,March,April,May,June,July,August,September,October,November,December");
$global_pref['mon'] = explode(",", "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec");

// some settings for dates and archives..
$global_pref['archive_link']= "Go to <a href='%url%'>%name%</a>";
$global_pref['archive_linkfile']= "<a href='%url%'>%st_day% %st_monname% - %en_day% %en_monname% %st_year% </a><br>\n";

$global_pref['diffdate_format'] ="%day%.%month%.%ye%";
$global_pref['entrydate_format'] ="%hour24%.%minute%";
$global_pref['fulldate_format'] ="%day%.%month%.%ye% - %hour24%.%minute%";

$global_pref['entryprevious']="previous entry: <a href='%link%' target='_self'>%title%</a>";
$global_pref['entrynext']="&nbsp;&nbsp; next entry: <a href='%link%' target='_self'>%title%</a>";
$global_pref['archiveprevious']="next archive";
$global_pref['archivenext']="previous archive";

$global_pref['referrer_date']="%hour24%:%minute% ";
$global_pref['referrer_show']=11;
$global_pref['referrer_maxlength']=17;
$global_pref['stats_lines']=400;

// some settings for uploading files..
$global_pref['upload_path'] = "images/";
$global_pref['upload_filename'] = "userfile";
$global_pref['upload_accept'] = "";
$global_pref['upload_extension'] = "";
$global_pref['upload_save_mode'] = 2;		
$global_pref['max_filesize']= 5000000;

$global_pref['last_comments_format']="<a href='%url%' %popup% title='%date%: %comm%'><b>%name%</b>: %title%</a><br>";
$global_pref['last_comments_trim']=20;
$global_pref['last_comments_comment_length']=60;
$global_pref['last_comments_count']=10;

?>