<?php

$rows = 0;
$list = "";

// get the file with the last referrers..
if (file_exists("db/ref/last_referrers.txt")) {
	$reffile="db/ref/last_referrers.txt";
} else {
	$reffile=$pivot_dir."db/ref/last_referrers.txt";
}
$aAll = file($reffile);

// get the file with the titles and parse it.
if (file_exists("db/ref/ref_titles.txt")) {
	$titlefilename="db/ref/ref_titles.txt";
} else {
	$titlefilename=$pivot_dir."db/ref/ref_titles.txt";
}
if (file_exists($titlefilename)){ 
	$title_file = file($titlefilename);
	foreach($title_file as $title){
		list ($key,$value) = explode("|", $title);
		$titles[$key]=trim($value);
	}
} else {
	$titles = Array();
}



if (file_exists($pivot_dir."config.inc.php")) {
	include $pivot_dir."config.inc.php";
}

if (!isset($global_pref['referrer_date'])) {
	$global_pref['referrer_date']="%hour24%.%minute%";
}

if (isset($HTTP_GET_VARS['show'])) {
	$maxrows = $HTTP_GET_VARS['show'];
} else {
	if (isset($global_pref['referrer_show'])) {
		$maxrows= $global_pref['referrer_show'];	
	} else {
		$maxrows = 16;
	}
}


if (isset($HTTP_GET_VARS['maxlength'])) {
  $maxlength = $HTTP_GET_VARS['maxlength'];
} else {
	if (isset($global_pref['referrer_maxlength'])) {
		$maxlength= $global_pref['referrer_maxlength'];	
	} else {
		$maxlength = 15;
	}
}


function format_date( $date, $format) {
	global $global_pref, $current_date;
	
	if ($format=="") { $format=$global_pref['entrydate_format']; }
	if ($date=="") {$date= $current_date; }
	list($yr,$mo,$da,$ho,$mi)=split("-",$date);
	$mo_name=$global_pref['months'][-1+$mo];
	$da_name=$global_pref['weekdays'][date("w",mktime(0,0,0,$mo,$da,$yr))];
	$wk_num=floor(date("z",mktime(0,0,0,$mo,$da,$yr)) / 7)+1;
	$ye=substr($yr,2);
	$ho12=$ho;
	if ($ho12>11) { $ho12=$ho12-12; }
	$ampm= ($ho12==$ho) ? "am" : "pm";
	if ($ho12==0) { $ho12=12; }

	
	$format=str_replace("%minute%", $mi, $format);
	$format=str_replace("%hour12%", $ho12, $format);
	$format=str_replace("%ampm%", $ampm, $format);
	$format=str_replace("%hour24%", $ho, $format);
	$format=str_replace("%day%", $da, $format);
	$format=str_replace("%weekday%", $da_name, $format);
	$format=str_replace("%weeknum%", $wk_num, $format);
	$format=str_replace("%month%", $mo, $format);
	$format=str_replace("%monthname%", $mo_name, $format);
	$format=str_replace("%monname%", $mo_name, $format);
	$format=str_replace("%year%", $yr, $format);
	$format=str_replace("%ye%", $ye, $format);

	return $format;
}

function cut($str)
{
	global $maxlength; 

	$str = str_replace('http://', '', $str);
	$str = str_replace('www.', '', $str);

	if (strlen($str) > $maxlength)
	  $str = substr($str, 0, $maxlength). "..";

	$str = str_replace(' ', '&nbsp;', $str);

	return stripslashes($str);
}

function disp_title($text, $extra) {
	global $titles;

	if (strpos($text, "?")) { $text=substr($text,0, strpos($text, "?") ); }
	$text=str_replace("/index.php", "", $text);
	$text=str_replace("/index.html", "", $text);
	$text=str_replace("/index.htm", "", $text);
	$text=str_replace("/index.shtml", "", $text);
	if ((strlen($text) - strrpos($text, "/")) == 1 ) { $text=substr($text,0,(strlen($text)-1)); }

	if (isset($titles[$text])) {
		if ($extra) {
			return $titles[$text]." - ". stripslashes(htmlentities($text));
		} else {
			return $titles[$text];
		}
	} else {
		$text = stripslashes(htmlentities($text));
		return $text;
	}

}

function disp_href($text) {

	$text = stripslashes(htmlentities($text));

	return $text;

}


function add_title($key, $value) {
	global $titles;

	if (strpos($key, "?")) {
		$key=substr($key,0, strpos($key, "?") );
	}
	$key=str_replace("%7E", "~", $key);
	
	if ((strlen($key) - strrpos($key, "/")) == 1 ) {
		$key=substr($key,0,(strlen($key)-1));
	}
	
	$titles[$key]=$value;

}

$dupes= Array();

//$maxrows=100;

for ($i=0;($i<count($aAll) && $rows<$maxrows);$i++)
{
	$one_row = explode("|", $aAll[$i]);
	
	$title=disp_title($one_row[1], FALSE);

	if (strpos($one_row[1], '.google.')) { 
		preg_match("~q=([a-zA-Z0-9%+]*)~is", $one_row[1], $match);
		@$match=urldecode($match[1]);
		$match=str_replace("+", " ", $match);
		$match=str_replace("%22", "'", $match);
		$title="[G] ".$match; 
		add_title($one_row[1],$title);
	}	

	if ( (strpos($one_row[1], 'zoek.lycos.')) || (strpos($one_row[1], 'search.lycos.')) ) {  
		preg_match("~query=([a-zA-Z0-9%+]*)~is", $one_row[1], $match);
		@$match=urldecode($match[1]);
		$match=str_replace("+", " ", $match);
		$match=str_replace("%22", "'", $match);
		$title="[L] ".$match; 
		add_title($one_row[1],$title);
	}	

	// http://search.msn.be/results.asp?q=dagboek%2Butrecht&origq=dagboek&FORM=IE4&v=1&cfg=SMCSP&nosp=0&thr=
	if (strpos($one_row[1], 'search.msn')) { 
		preg_match("~q=([a-zA-Z0-9%+]*)~is", $one_row[1], $match);
		@$match=urldecode($match[1]);
		$match=str_replace("+", " ", $match);
		$match=str_replace("%22", "'", $match);
		$title="[M] ".$match; 
		add_title($one_row[1],$title);
	}	

	// http://nl.altavista.com/web/results?q=Sanne+Lesley&kgs=1&kls=1&avkw=qtrp
	if (strpos($one_row[1], '.altavista.')) { 
		preg_match("~q=([a-zA-Z0-9%+]*)~is", $one_row[1], $match);
		@$match=urldecode($match[1]);
		$match=str_replace("+", " ", $match);
		$match=str_replace("%22", "'", $match);
		$title="[A] ".$match; 
		add_title($one_row[1],$title);
	}	
	
	//http://search.yahoo.com/search?p=lesley+sanne
	if (strpos($one_row[1], '.yahoo.')) { 
		preg_match("~p=([a-zA-Z0-9%+]*)~is", $one_row[1], $match);
		@$match=urldecode($match[1]);
		$match=str_replace("+", " ", $match);
		$match=str_replace("%22", "'", $match);
		$title="[Y] ".$match; 
		add_title($one_row[1],$title);
	}	


	if (strlen($one_row[1]) && (!strpos($one_row[1], $HTTP_SERVER_VARS['HTTP_HOST'])) && (!in_array($title, $dupes)) )
	{
		$date= format_date($one_row[0], $global_pref['referrer_date']);

		if (strlen($date)>3) {
			$list .= $date;
			$list .= "&nbsp;<a ";
			$list .= "title=\"".disp_title($one_row[1], TRUE)."\" ";
			$list .= "href=\"".disp_href($one_row[1])."\" target='_blank'>";
			$list .= cut($title);
			$list .= "</a><br />";
		}

		$dupes[]=$title;

		$rows++;
	}
}

print $list;

?>