<?

combine_parameters();

if (isset($skip_login)) {
	$url="index.php?m=Get%20Lost!!";
	header("Location: ".$url);
	echo "<script>self.location='$url';</script>";
}

// set the env. vars if php version > 4.2.0 
if (check_php_version('4.2.0')) {
	$PHP_SELF=$_SERVER['PHP_SELF'];
	$REMOTE_ADDR=$_SERVER['REMOTE_ADDR'];
	$HTTP_USER_AGENT=$_SERVER['HTTP_USER_AGENT'];
	@$HTTP_SESSION_VARS=$_SESSION;
}


function mysetcookie($name,$data,$exp) { 
	$c=sprintf("<META HTTP-EQUIV=\"Set-Cookie\" CONTENT=\"%s=%s",$name,$data); 
	if($exp>0) { 
		// the 'y' must be lowercase if the browser don't work with full year, but then maybe will be problems with Y2k 
		$d=date("l, d-M-Y H:i:s CST",$exp); 
		$c.=";$d"; 
	} 
	$c.="\">\n"; 
	echo $c; 
} 

function check_php_version($version) {
// intval used for version like "4.0.4pl1"
    $testVer=intval(str_replace(".", "",$version));
    $curVer=intval(str_replace(".", "",phpversion()));
    if( $curVer < $testVer )
      return false;
    return true;
}

function combine_parameters() {

	global $PIV_PARA, $PIV_COOKIES, $HTTP_GET_VARS , $HTTP_POST_VARS, $HTTP_COOKIE_VARS , $HTTP_SESSION_VARS, $PHP_SELF, $REMOTE_ADDR, $HTTP_USER_AGENT, $HTTP_SERVER_VARS ;

	$PIV_PARA= array_merge($HTTP_GET_VARS , $HTTP_POST_VARS);
	$PIV_COOKIES = array_merge($HTTP_COOKIE_VARS , $HTTP_SESSION_VARS);
	

	// and some environment variables..
	if (!isset($_SERVER)) { $_SERVER=$HTTP_SERVER_VARS; }
	$PHP_SELF=$_SERVER['PHP_SELF'];
	$REMOTE_ADDR=$_SERVER['REMOTE_ADDR'];
	$HTTP_USER_AGENT=$_SERVER['HTTP_USER_AGENT'];
	// @$HTTP_SESSION_VARS=$_SESSION;

}

// print debug info..
function debug($line) {
global $global_pref;
	if ($global_pref['debug']=="yes") {
		echo "<span class='timetaken'>- $line -</span><br>\n";
	}
}

// Add a line to the log file.
function add_log($entry, $user="") {
	global $log_date, $global_pref, $username, $REMOTE_ADDR;

	if ($user=="") { $user=$username; }

	if ($global_pref['log_access']) {
		if($fp=fopen("db/logfile.txt.php", "a-")) {
			fwrite($fp, "[$log_date / ip:".$REMOTE_ADDR."] - $user - $entry\n");
			fclose($fp);
		}
	}
}

// check trailing whitespace in config.inc.php
function check_config_whitespace() {

	$file=implode("", file("config.inc.php"));

	$trimfile=trim($file);

	if (strlen($trimfile)!=strlen($file)) {
		return TRUE;
	} else {
		return FALSE;
	}

}


include "config.inc.php";
include "users.php";
$log_date=date("Y:m:d - H:i");

// check if headers are already sent.. In fact this checks if config.inc.php has trailing whitespace.
if (check_config_whitespace()) {

	echo "It seems your config.inc.php file has extra trailing whitespace (or in english: 'extra lines at the end of the file'). Pivot will not work properly because of this. You should fix this by hand, or let Pivot fix this for you. <BR><BR>\n";

	echo "I will fix it myself, so go the <A href='index.php'>logon screen</a>.<BR><BR>\n";

	echo "<A href='fix_config.php'>Pivot should fix it</a>, and then go to the logon screen.<BR><BR>\n";

	die();

}


$global_pref['pivot_url']= dirname(isset($PATH_INFO) ? $PATH_INFO : $PHP_SELF)."/";
if (strpos($global_pref['pivot_url'], "php.exe") > 0) { $global_pref['pivot_url']= substr($global_pref['pivot_url'], strpos($global_pref['pivot_url'], "php.exe")+7); }


// check if a submitted password is ok..
function password_ok($user, $pass){
global $global_user;

	return ( ($user!="") && ($pass!="") && 
		( ($global_user[$user]['password']==md5($pass)) || ($global_user[$user]['password']==$pass) ) );
}

// redirect. first through header, otherwise by javascript..
function redirect($url, $rand = 0) {
global $global_pref;

	// change the redirect to a full url. Some browsers/webservers need this..
	if ($global_pref['redirect']=="absolute") {
		$url=$global_pref['pivot_url'].$url;
	}


	if ($global_pref['debug']=="yes") {
		echo "<br><br><a href=\"$url\">$url</a>";
	} else {
		@header("Location: ".$url);
		echo "<script>self.location='$url';</script>";
		die();
	}

}



if  ( (password_ok($HTTP_POST_VARS['f_user'], $HTTP_POST_VARS['f_pass']))  ) {

	$f_user=$HTTP_POST_VARS['f_user'];
	$f_pass=$HTTP_POST_VARS['f_pass'];

	$current_user=$f_user;
	$current_user_path=$global_pref['pivot_url'];
	$current_user_nickname=$global_user[$f_user]['nickname'];
	$current_user_email=$global_user[$f_user]['email'];
	$current_user_admin=$global_user[$f_user]['admin'];

	//
	// Set session variables..
	//
	session_register("current_user");
	session_register("current_user_path");
	session_register("current_user_nickname");
	session_register("current_user_email");
	session_register("current_user_admin");

	//
	// Set Cookies
	//
	if (isset($PIV_PARA['cookie'])) {

		setcookie("cookie_user", $f_user, time()+2592000, $global_pref['pivot_url']);
		setcookie("cookie_pass", $f_pass, time()+2592000, $global_pref['pivot_url']);
		setcookie("cookie_path", $global_pref['pivot_url'], time()+2592000, $global_pref['pivot_url']);

	} else {

		setcookie("cookie_user", "", time()-1000, $global_pref['pivot_url']);
		setcookie("cookie_pass", "", time()-1000, $global_pref['pivot_url']);
		setcookie("cookie_path", "", time()-1000, $global_pref['pivot_url']);

	}


	

	if (check_php_version('4.2.0')) {

		$_SESSION['current_user']=$f_user;
		$_SESSION['current_user_path']=$global_pref['pivot_url'];
		$_SESSION['current_user_nickname']=$global_user[$f_user]['nickname'];
		$_SESSION['current_user_email']=$global_user[$f_user]['email'];
		$_SESSION['current_user_admin']=$global_user[$f_user]['admin'];

	} else {

		$HTTP_SESSION_VARS['current_user']=$f_user;
		$HTTP_SESSION_VARS['current_user_path']=$global_pref['pivot_url'];
		$HTTP_SESSION_VARS['current_user_nickname']=$global_user[$f_user]['nickname'];
		$HTTP_SESSION_VARS['current_user_email']=$global_user[$f_user]['email'];
		$HTTP_SESSION_VARS['current_user_admin']=$global_user[$f_user]['admin'];

	}

	if (isset($cookie)) {
		add_log("logged in successfully, cookies enabled", $current_user);
	} else {
		add_log("logged in successfully, no cookies", $current_user);
	}



	debug("logged in as: $current_user");

	if (isset($redirect)) {
		// redir given as a form variable..
		redirect($redirect);
	} else {
		redirect("overview.php");
	}

} else {

	setcookie("cookie_user", "", time()-1000, $global_pref['pivot_url']);
	setcookie("cookie_pass", "", time()-1000, $global_pref['pivot_url']);
	setcookie("cookie_path", "", time()-1000, $global_pref['pivot_url']);

	add_log("Failed login", "(".$HTTP_POST_VARS['f_user'].")");

	redirect("index.php?m=Wrong%20user/password%20combo..");

}

?>
