<?
$skip_login="yes";

include_once "config.inc.php";
include_once "common.php";
include_once "module_archive.php";
include_once "module_parser.php";



function show_form($formtype, $show_login, $include_script, $alert_word ) {
global $PHP_SELF, $PIV_PARA, $PIV_COOKIES, $user, $global_pref, $base, $link, $hidden;

	$form=file("extra/logform_mini.html");
	
	$db= new db_xml('standard',TRUE);
	$categories=$db->get_categories_select();

	for ($i=0;$i<count($form);$i++) {

		$form[$i]=str_replace("%hidden%",$hidden, $form[$i]);
		$form[$i]=str_replace("%pass%",$user['password'], $form[$i]);
		$form[$i]=str_replace("%user%",$user['name'], $form[$i]);
		$form[$i]=str_replace("%self%",$PHP_SELF, $form[$i]);

		$form[$i]=str_replace("%link%",$link, $form[$i]);
		$form[$i]=str_replace("%cat%",$categories, $form[$i]);
		$form[$i]=str_replace("%script%",$include_script, $form[$i]);

		$form[$i]=str_replace("%title%", txt2form($PIV_PARA['f_title']), $form[$i]);
		@$form[$i]=str_replace("%image%",$PIV_PARA['f_image'], $form[$i]);
		@$form[$i]=str_replace("%width%",$PIV_PARA['f_width'], $form[$i]);
		@$form[$i]=str_replace("%height%",$PIV_PARA['f_height'], $form[$i]);
		@$form[$i]=str_replace("%introduction%",stripslashes($PIV_PARA['f_introduction']), $form[$i]);
		@$form[$i]=str_replace("%postponed%",($PIV_PARA['f_postpone']) ? "checked" : "", $form[$i]);
		echo "$form[$i]";
	}
	
	if ($alert_word) {
		echo "<script>\nalert('You can not paste word-html directly. All word-specific markup has been deleted, so if your entry looks allright, you can submit again')\n</script>";
	}

	die();

}

function show_form_login() {
global $PHP_SELF, $version, $global_pref;

	include "extra/loginform.html";
	die();

}


// initialize variables, if necessary
if (!isset($PIV_PARA['f_title'])) {
	$PIV_PARA['f_title']="";
	$PIV_PARA['f_image']="";
	$PIV_PARA['f_width']="";
	$PIV_PARA['f_height']="";
	$PIV_PARA['f_introduction']="";
	$PIV_PARA['f_postpone']="";
}



if (isset($url)) {
	$link=sprintf("<a href=\"%s\">%s</a>",stripslashes($url), stripslashes($title));
} else {
	$link="";
}


// Check to see if we can post it.
$posting=FALSE;

if (check_login_or_cookie()) {
	debug("post vw login of cookie");
	$posting=TRUE;
}

if ( (isset($PIV_PARA['f_user']))&& (password_ok($PIV_PARA['f_user'], $PIV_PARA['f_pass'])) ) {
	debug("post vw ingetypt");
	$user['name']=$PIV_PARA['f_user'];
	$user['password']=$PIV_PARA['f_pass'];
	$posting=TRUE;
}

if ( (isset($PIV_PARA['f_introduction'])) && (is_word_html($PIV_PARA['f_introduction'])) ) {
	$posting=false;
	$PIV_PARA['f_introduction']=strip_word_html($PIV_PARA['f_introduction']);
	//echo "intro: $f_introduction";
	$alert_word=TRUE;
} else {
	$alert_word=FALSE;
}



if  ( ($posting) && (isset($PIV_PARA['f_introduction'])) && ($PIV_PARA['f_introduction']!="") && ($PIV_PARA['f_mode']=="") ) {

	// All set. enter the log..

	$row=Array();
	$row['code']=">";
	$row['template']="blogentry.html";
	
	if (isset($PIV_PARA['f_postpone'])) {
		$row['date']="2010-01-01-00-00";
	} else {
		$row['date']=$current_date;
	}
	$row['user']=$user['name'];
	$row['title']=stripslashes($PIV_PARA['f_title']);
	$row['subtitle']="";

	// the automagic html-edit tends to include absolute paths. we don't want that..
	$path="http://".$HTTP_SERVER_VARS['HTTP_HOST'].$global_pref['pivot_url']."extra/";
	$PIV_PARA['f_introduction']=str_replace($path,"",$PIV_PARA['f_introduction']);

	//the automagic html-edit also tends to include <p> tags. This is not good..
	$PIV_PARA['f_introduction']=strip_trailing_space($PIV_PARA['f_introduction']);

	$pos=strpos($PIV_PARA['f_introduction'], "-more-");
	if ($pos==0) {
		$pos=strpos(strtolower($PIV_PARA['f_introduction']), "<hr>");
	}
	if ($pos>0) {
		$row['introduction']=trim(substr($PIV_PARA['f_introduction'],0,$pos));
		$row['body']=trim(substr($PIV_PARA['f_introduction'],$pos+6));
	} else {
		$row['introduction']=trim(stripslashes($PIV_PARA['f_introduction']));
		$row['body']="";

	}
	$row['media']=$PIV_PARA['f_image'];
	
	if (isset($PIV_PARA['f_cat'])) {
		$row['category']=$PIV_PARA['f_cat'];
	} else {
		$row['category']='standard';
	}

	$db= new db_xml('standard',TRUE);
	$db->set_entry($row);
	$db->savexml();

	// generate the new entry
	if ($global_pref['live_comments']) {
		generate_page("","live","");
		$entryfilename=$db->entry['id'];
		// debug("uid: ". $entryfilename);
	} else {
		$entryfilename=generate_page("","","");
	}

	//generate the last archive();
	$arc_num=get_archive_num($db->entry['date']);
	create_archive_index($arc_num);
	generate_last_archive();



	// generate front-page
	$file=$db->set_filename('standard');
	$db->read_entry($file,FALSE);
	$logfilename=generate_page("","","");

	add_log("New entry '".$row['title']."'");

	// finally, redirect to the new page..
	show_posted_menu($entryfilename, $PIV_PARA['f_postpone']);
	//redirect($entryfilename);

} else {

	// if we're not posting yet, we either have to log in 
	// or type a entry..

	if ( (ie5up()) && ($global_pref['wysiwyg_editor']=="yes") ) {
		$form='ie';
	} else {
		$form='other';
	}

	// perhaps force wysywig mode, or not..
	if ((isset($PIV_PARA['f_mode'])) && ($PIV_PARA['f_mode']=="plain") ){
		$form='other';
	} else if ((isset($PIV_PARA['f_mode'])) && ($PIV_PARA['f_mode']=="wysiwyg") ) {
		$form='ie';
	}


	if (ie5up()) {
		$include_script="form_shortcuts_ie.js";
	} else {
		$include_script="form_shortcuts_alt.js";
	}

	if (check_login_or_cookie()) {
		//$f_user=$user['name'];
		//$f_pass=$user['password'];
		// debug("user++ = ".$user['name']." , ". $user['password']);
		$show_login=0;
	} else {
		// debug("nok");
		$show_login=1;
	}

	show_form($form, $show_login, $include_script, $alert_word);

}


?>
